#include <pic16f84a.h>
/* ejerext3.c
 * Jose Luis Dobler Trueba
 * Leer los microswitches.  Si A1 = 1, Encender los leds comenzando por B0, B2..
 * y asi sucesivamente hasta B6...Si A1 = 0, encender B1, luego B3 y asi sucesi-
 * vamente hasta B7.  Retraso de 200 ms.  Repetir rutina.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext3.c */

#define TIEMPO 10000

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(void) {
	unsigned int i;
	for(i = 0; i < TIEMPO; i++);
	return PORTA;
}

void main(void) {

	char i, num;

	PORTA = 0;
	PORTB = 0;
	TRISA = 0xfe;
	TRISB = 0;

	while(1) {
		num = (check() & 0x02) >> 1;
		PORTB = (num) ? 0x01 : 0x02;
		check();
		for(i = 0; i < 4; i++) {
			PORTB = PORTB << 2;
			check();
		}
	}
}
